//////////////////////////////////////////////////////////////////////////////
//
// Minimal
// Copyright 2004 by Thierry Tremblay
//
// Minimal Sample for PocketHAL
// For more info: http://www.droneship.com
//
//////////////////////////////////////////////////////////////////////////////

#ifndef INCLUDED_MINIMAL_H
#define INCLUDED_MINIMAL_H

#include <PocketHAL/PocketHAL.h>
#include "game.h"

using namespace PHAL;


#define MOVING_AREA_WIDTH		200
#define SQUARE_SIZE				10
#define SQUARE_SPEED			80

//////////////////////////////////////////////////////////////////////////////
//
// GameCore
//
//////////////////////////////////////////////////////////////////////////////

VOID FillRect(PHAL::Surface * p_pSurface, INT p_iLeft, INT p_iTop, INT p_iWidth, INT p_iHeight, unsigned __int16 p_iColor);

class GameCore : public Game
{
public:

    enum { UID = 0x0B6BE65F };

					GameCore();
					~GameCore();

	// Physics threading
	HANDLE			m_hPhysicsThread;
	
	// Physics processing
	VOID			DoPhysics();

protected:
    
    virtual bool	OnInitialize();          // Return true or false depending on success
    virtual bool	OnGameLoop();            // Game loop, return true to continue running or false to shutdown


private:

	// Physics data
	double			m_dX, m_dXSpeed;
	DWORD			m_dwLastSystemTick;
};




#endif
